/*
 *  Copyright (C) 2008  Thadeu Lima de Souza Cascardo <cascardo@holoscopio.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */


#include <atompub/atom.h>

#include <glib.h>

struct _atom_resource
{
  char *str;
  size_t len;
};

AtomResource *
atom_resource_new_from_feed (AtomFeed *feed)
{
  AtomResource *res;
  res = g_slice_new (AtomResource);
  atom_feed_string (feed, &(res->str), &(res->len));
  return res;
}

AtomResource *
atom_resource_new_from_entry (AtomEntry *entry)
{
  AtomResource *res;
  res = g_slice_new (AtomResource);
  atom_entry_string (entry, &(res->str), &(res->len));
  return res;
}

void
atom_resource_delete (AtomResource *res)
{
  if (res->str)
    g_free (res->str);
  g_slice_free (AtomResource, res);
}

void
atom_resource_string (AtomResource *res, char **buffer, size_t *len)
{
  if (buffer)
    *buffer = g_strdup (res->str);
  if (len)
    *len = res->len;
}
